/**
 * EIVLPPDTS.java
 *
 * File generated from the medication::EIVLPPDTS uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class EIVLPPDTS.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EIVL_PPD_TS", propOrder = {
	"event",
	"offset"
})
@XmlRootElement(name = "EIVL_PPD_TS")
public class EIVLPPDTS extends net.ihe.gazelle.medication.SXCMPPDTS implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      .
	 */
	@XmlElement(name = "event", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.EIVLEvent event;
	/**
	 *                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      .
	 */
	@XmlElement(name = "offset", namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.IVLPPDPQ offset;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return event.
	 * @return event :                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      
	 */
	public net.ihe.gazelle.medication.EIVLEvent getEvent() {
	    return event;
	}
	
	/**
	 * Set a value to attribute event.
	 * @param event :                          A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                                               A code for a common
	                                (periodical) activity of daily                         living based
	                                on which the event related periodic                         interval
	                                is specified.                      .
	 */
	public void setEvent(net.ihe.gazelle.medication.EIVLEvent event) {
	    this.event = event;
	}
	
	
	
	
	/**
	 * Return offset.
	 * @return offset :                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      
	 */
	public net.ihe.gazelle.medication.IVLPPDPQ getOffset() {
	    return offset;
	}
	
	/**
	 * Set a value to attribute offset.
	 * @param offset :                          An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                                               An interval of elapsed time
	                                (duration, not absolute                         point in time) that
	                                marks the offsets for the                         beginning, width
	                                and end of the event-related periodic
	                                interval measured from the time each such event
	                                actually occurred.                      .
	 */
	public void setOffset(net.ihe.gazelle.medication.IVLPPDPQ offset) {
	    this.offset = offset;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "EIVL_PPD_TS").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(EIVLPPDTS eIVLPPDTS, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eIVLPPDTS != null){
   			net.ihe.gazelle.medication.SXCMPPDTS.validateByModule(eIVLPPDTS, location, cvm, diagnostic);
			net.ihe.gazelle.medication.EIVLEvent.validateByModule(eIVLPPDTS.getEvent(), location + "/event", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLPPDPQ.validateByModule(eIVLPPDTS.getOffset(), location + "/offset", cvm, diagnostic);
    	}
    }

}